package alfred.web.core

fun processBuilder(config: BuildConfig, logFile: LogFile, rev: String): ProcessBuilder =
    ProcessBuilder()
        .redirectOutput(ProcessBuilder.Redirect.appendTo(logFile.backingFile))
        .redirectError(ProcessBuilder.Redirect.appendTo(logFile.backingFile))
        .apply {
            environment().putAll(config.env)
            environment()["ALFRED_LOG_FILE"] = logFile.backingFile.absolutePath
            environment()["ALFRED_REV"] = rev
        }
