package alfred.web.http

import alfred.web.core.BuildConfig
import alfred.web.core.BuildId
import alfred.web.core.Builds
import org.springframework.http.HttpStatus
import org.springframework.http.ResponseEntity
import org.springframework.stereotype.Service

@Service
class Security(
    val builds: Builds
) {

    fun <T> requireKey(build: BuildId, apikey: String?, block: (BuildConfig) -> T): ResponseEntity<*> {
        val buildConfig = builds.buildConfig(build)
        if (buildConfig.apikey != "" && buildConfig.apikey != apikey) {
            return ResponseEntity<T>(HttpStatus.UNAUTHORIZED)
        }

        val entity = block(buildConfig)
        if (entity is ResponseEntity<*>) {
            return entity
        }

        return ResponseEntity.ok(entity)
    }

}
